Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm	(revision 34921)
@@ -678,54 +2460,484 @@
             2 => 'AF-C',
             3 => 'AF-A',
-        },
-    },
-    0x11 => { #JD (A700)
-        Name => 'AFAreaMode',
-        PrintConv => {
-            0 => 'Wide',
-            1 => 'Local',
-            2 => 'Spot',
-        },
-    },
-    0x12 => { #7 (A700, not confirmed for other models)
-        Name => 'LocalAFAreaPoint',
-        Format => 'int16u',
-        Condition => '$$self{Model} !~ /DSLR-A230/',
-        PrintConv => {
+            4 => 'DMF',
+        },
+    },
+    0x0015 => { # the AF Point selected in AFAreaMode=Local or Spot; always '0' for AFAreaMode=Wide
+        Name => 'AFPointSelected',
+        PrintConvColumns => 2,
+        PrintConv => {
+            0 => 'Auto',
             1 => 'Center',
             2 => 'Top',
-            3 => 'Top-Right',
+            3 => 'Upper-right',
             4 => 'Right',
-            5 => 'Bottom-Right',
+            5 => 'Lower-right',
             6 => 'Bottom',
-            7 => 'Bottom-Left',
+            7 => 'Lower-left',
             8 => 'Left',
-            9 => 'Top-Left',
+            9 => 'Upper-left',
+            10 => 'Far Right', # only given by A700
+            11 => 'Far Left',  # only given by A700
+        },
+    },
+    # 0x0019 - AF sensor used for focusing for A700/A850/A900:
+    #
+    #   A700 AF sensor layout:         A850/A900 AF sensor layout:
+    #
+    #              -                             *-*                 - = AF sensor
+    #        |           |                  |           |            * = assist sensor
+    #              -                             *-*                 o = F2.8 sensor
+    #   |    |    |o|    |    |        |    *    |o|    *    |       A700 center: double-cross + F2.8
+    #              -                             *-*                 A850 center: double-cross + F2.8 + 4 assist
+    #        |           |                  |           |
+    #              -                             *-*
+    #
+    # Following values seen for A700/A850 in AFAreaMode=Local or Spot: (other values only seen in "Wide")
+    #
+    #              16
+    #         0           19
+    #              13
+    #    3    1    22     20    18
+    #               8
+    #         2           21
+    #               5
+    #
+    # Note 1: A850/A900 AFPoint Selected 'Left'/'Right' (in 0x0015) corresponds in position (see diagram)
+    #         to A700 Local AFPoint 'Far Left'/'Far Right', and gives 'Far Left'/'Far Right' in 0x0019.
+    # Note 2: A700 in "Wide" also gives all 23 values in 0x0019, although it doesn't have assist-points ...
+    0x0019 => { # the AF sensor used for focusing
+        Name => 'AFPoint',
+        PrintConv => {
+            0 => 'Upper-left',
+            1 => 'Left',
+            2 => 'Lower-left',
+            3 => 'Far Left',
+            4 => 'Bottom Assist-left', #(NC)
+            5 => 'Bottom',
+            6 => 'Bottom Assist-right', #(NC)
+            # values 7-14: 8 center points: 4 from double-cross + 4 assist; 7-10 appear horizontal, 11-14 vertical
+            7  => 'Center (7)', #(NC)
+            8  => 'Center (horizontal)',
+            9  => 'Center (9)', #(NC)
+            10 => 'Center (10)', #(NC)
+            11 => 'Center (11)', #(NC)
+            12 => 'Center (12)', #(NC)
+            13 => 'Center (vertical)',
+            14 => 'Center (14)', #(NC)
+            15 => 'Top Assist-left', #(NC)
+            16 => 'Top',
+            17 => 'Top Assist-right', #(NC)
+            18 => 'Far Right',
+            19 => 'Upper-right',
+            20 => 'Right',
+            21 => 'Lower-right',
+            22 => 'Center F2.8',
+        },
+    },
+    # AF Status for A700/A850/A900, which have different sensor layout
+    # and different int16 byte ordering
+    0x001e => { Name => 'AFStatusActiveSensor',       %Image::ExifTool::Minolta::afStatusInfo },
+    0x0020 => { Name => 'AFStatusUpper-left',         %Image::ExifTool::Minolta::afStatusInfo },
+    0x0022 => { Name => 'AFStatusLeft',               %Image::ExifTool::Minolta::afStatusInfo },
+    0x0024 => { Name => 'AFStatusLower-left',         %Image::ExifTool::Minolta::afStatusInfo },
+    0x0026 => { Name => 'AFStatusFarLeft',            %Image::ExifTool::Minolta::afStatusInfo },
+    0x0028 => { Name => 'AFStatusBottomAssist-left',  %Image::ExifTool::Minolta::afStatusInfo },
+    0x002a => { Name => 'AFStatusBottom',             %Image::ExifTool::Minolta::afStatusInfo },
+    0x002c => { Name => 'AFStatusBottomAssist-right', %Image::ExifTool::Minolta::afStatusInfo },
+    0x002e => { Name => 'AFStatusCenter-7',           %Image::ExifTool::Minolta::afStatusInfo },
+    0x0030 => { Name => 'AFStatusCenter-horizontal',  %Image::ExifTool::Minolta::afStatusInfo },
+    0x0032 => { Name => 'AFStatusCenter-9',           %Image::ExifTool::Minolta::afStatusInfo },
+    0x0034 => { Name => 'AFStatusCenter-10',          %Image::ExifTool::Minolta::afStatusInfo },
+    0x0036 => { Name => 'AFStatusCenter-11',          %Image::ExifTool::Minolta::afStatusInfo },
+    0x0038 => { Name => 'AFStatusCenter-12',          %Image::ExifTool::Minolta::afStatusInfo },
+    0x003a => { Name => 'AFStatusCenter-vertical',    %Image::ExifTool::Minolta::afStatusInfo },
+    0x003c => { Name => 'AFStatusCenter-14',          %Image::ExifTool::Minolta::afStatusInfo },
+    0x003e => { Name => 'AFStatusTopAssist-left',     %Image::ExifTool::Minolta::afStatusInfo },
+    0x0040 => { Name => 'AFStatusTop',                %Image::ExifTool::Minolta::afStatusInfo },
+    0x0042 => { Name => 'AFStatusTopAssist-right',    %Image::ExifTool::Minolta::afStatusInfo },
+    0x0044 => { Name => 'AFStatusFarRight',           %Image::ExifTool::Minolta::afStatusInfo },
+    0x0046 => { Name => 'AFStatusUpper-right',        %Image::ExifTool::Minolta::afStatusInfo },
+    0x0048 => { Name => 'AFStatusRight',              %Image::ExifTool::Minolta::afStatusInfo },
+    0x004a => { Name => 'AFStatusLower-right',        %Image::ExifTool::Minolta::afStatusInfo },
+    0x004c => { Name => 'AFStatusCenterF2-8',         %Image::ExifTool::Minolta::afStatusInfo },
+    0x0130 => {
+        Name => 'AFMicroAdjValue',
+        Condition => '$$self{Model} =~ /^DSLR-A(850|900)\b/',
+        ValueConv => '$val - 20',
+        ValueConvInv => '$val + 20',
+    },
+    0x0131 => {
+        Name => 'AFMicroAdjMode',
+        Condition => '$$self{Model} =~ /^DSLR-A(850|900)\b/',
+        Mask => 0x80,
+        PrintConv => {
+            0 => 'Off',
+            1 => 'On',
+        },
+    },
+    305.1 => { # (0x131)
+        Name => 'AFMicroAdjRegisteredLenses',
+        Notes => 'number of registered lenses with a non-zero AFMicroAdjValue',
+        Condition => '$$self{Model} =~ /^DSLR-A(850|900)\b/',
+        Mask => 0x7f,
+    },
+    # 0x0166 - 40 x 128 int8u values: AF Info Blocks for A850 and A900, not for A700
+);
+
+# camera information for other DSLR models (ref JR)
+%Image::ExifTool::Sony::CameraInfo2 = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => q{
+        Camera information for the DSLR-A200, A230, A290, A300, A330, A350, A380 and
+        A390.
+    },
+    0x00 => {
+        Name => 'LensSpec',
+        Format => 'undef[8]',
+        ValueConv => \&ConvLensSpec,
+        ValueConvInv => \&ConvInvLensSpec,
+        PrintConv => \&PrintLensSpec,
+        PrintConvInv => \&PrintInvLensSpec,
+    },
+    # 0x0010 - maybe to do with AFStatus: 0 na./Manual, 4 Failed, 16 Tracking, 64 Focused
+    0x0014 => {
+        Name => 'AFPointSelected',
+        PrintConvColumns => 2,
+        PrintConv => { #JR (NC) same list as A100, A700/A900, as all have 9 point AF
+            0 => 'Auto',
+            1 => 'Center',
+            2 => 'Top',
+            3 => 'Upper-right',
+            4 => 'Right',
+            5 => 'Lower-right',
+            6 => 'Bottom',
+            7 => 'Lower-left',
+            8 => 'Left',
+            9 => 'Upper-left',
+        },
+    },
+    0x0015 => {
+        Name => 'FocusModeSetting',
+        Notes => 'FocusModeSetting for other models',
+        PrintConv => {
+            0 => 'Manual',
+            1 => 'AF-S',
+            2 => 'AF-C',
+            3 => 'AF-A',
+            4 => 'DMF',
+        },
+    },
+    # 0x0018 - AF sensor used for focusing for A200/A230/A290/A300/A330/A350/A380/A390; AF sensor layout:
+    #
+    #               -              - = AF sensor
+    #        |              |      + = cross sensor
+    #
+    #            -  +  -
+    #
+    #        |              |
+    #               -
+    #
+    0x0018 => { # used A100 list which appears to match
+        Name => 'AFPoint',
+        PrintConv => {
+            0 => 'Top-right',
+            1 => 'Bottom-right',
+            2 => 'Bottom',
+            3 => 'Middle Horizontal',
+            4 => 'Center Vertical',
+            5 => 'Top',
+            6 => 'Top-left',
+            7 => 'Bottom-left',
+        },
+    },
+    # AF Status for A200/A230/A290/A300/A330/A350/A380/A390: analogous to A100 in Minolta.pm
+    0x001b => { Name => 'AFStatusActiveSensor',     %Image::ExifTool::Minolta::afStatusInfo },
+    0x001d => { Name => 'AFStatusTop-right',        %Image::ExifTool::Minolta::afStatusInfo },
+    0x001f => { Name => 'AFStatusBottom-right',     %Image::ExifTool::Minolta::afStatusInfo },
+    0x0021 => { Name => 'AFStatusBottom',           %Image::ExifTool::Minolta::afStatusInfo },
+    # MiddleHorizontal is any of the 3 central horizontal sensors
+    0x0023 => { Name => 'AFStatusMiddleHorizontal', %Image::ExifTool::Minolta::afStatusInfo },
+    0x0025 => { Name => 'AFStatusCenterVertical',   %Image::ExifTool::Minolta::afStatusInfo },
+    0x0027 => { Name => 'AFStatusTop',              %Image::ExifTool::Minolta::afStatusInfo },
+    0x0029 => { Name => 'AFStatusTop-left',         %Image::ExifTool::Minolta::afStatusInfo },
+    0x002b => { Name => 'AFStatusBottom-left',      %Image::ExifTool::Minolta::afStatusInfo },
+    # the 3 MiddleHorizontal sensors
+    0x002d => { Name => 'AFStatusLeft',             %Image::ExifTool::Minolta::afStatusInfo },
+    0x002f => { Name => 'AFStatusCenterHorizontal', %Image::ExifTool::Minolta::afStatusInfo },
+    0x0031 => { Name => 'AFStatusRight',            %Image::ExifTool::Minolta::afStatusInfo },
+    # 0x0166 -  59 x 96 int8u values: AF Info Blocks for A230/A290/A330/A380/A390
+    # 0x0182 -  58 x 88 int8u values: AF Info Blocks for A200/A300/A350
+);
+
+# Camera information for the A55 (ref PH)
+# (also valid for A33, A35, A560, A580 - ref JR)
+%Image::ExifTool::Sony::CameraInfo3 = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    IS_SUBDIR => [ 0x23 ],
+    NOTES => q{
+        Camera information stored by the A33, A35, A55, A450, A500, A550, A560,
+        A580, NEX-3/5/5C/C3 and VG10E.  Some tags are valid only for some of these
+        models.
+    },
+    0x00 => { #JR
+        Name => 'LensSpec',
+        Condition => '$$self{Model} !~ /^NEX-5C/',
+        Format => 'undef[8]',
+        ValueConv => \&ConvLensSpec,
+        ValueConvInv => \&ConvInvLensSpec,
+        PrintConv => \&PrintLensSpec,
+        PrintConvInv => \&PrintInvLensSpec,
+    },
+    0x0e => { #JR
+        Name => 'FocalLength',
+        Condition => '$$self{Model} !~ /^DSLR-(A450|A500|A550)$/',
+        Format => 'int16u',
+        Priority => 0,
+        ValueConv => '$val / 10',
+        ValueConvInv => '$val * 10',
+        PrintConv => 'sprintf("%.1f mm",$val)',
+        PrintConvInv => '$val =~ s/ mm//; $val',
+    },
+    0x10 => { #JR
+        Name => 'FocalLengthTeleZoom',
+        Condition => '$$self{Model} !~ /^DSLR-(A450|A500|A550)$/',
+        Format => 'int16u',
+        ValueConv => '$val * 2 / 3',
+        ValueConvInv => 'int($val * 3 / 2 + 0.5)',
+        PrintConv => 'sprintf("%.1f mm",$val)',
+        PrintConvInv => '$val =~ s/ mm//; $val',
+    },
+#
+# Note:
+# The below AF decoding covers cameras with 2 different AF systems, with overlapping offsets !
+#  1) DSLR-A450/A500/A550 with 9 point AF system: decoding/offsets identical to A200 - A390 in CameraInfo
+#  2) SLT-A33/A35/A55 and DSLR-A560/A580 with 15 point AF system: similar/more info but at different offsets
+#
+    0x14 => { #JR
+        Name => 'AFPointSelected',
+        Condition => '$$self{Model} =~ /^(DSLR-A(450|500|550))\b/',
+        # (these cameras have a 9-point AF system, ref JR)
+        PrintConvColumns => 2,
+        PrintConv => {
+            0 => 'Auto', # (seen in Wide mode and for Manual Focus)
+            1 => 'Center', # seen for AFArea=Spot
+            2 => 'Top',
+            3 => 'Upper-right',
+            4 => 'Right',
+            5 => 'Lower-right',
+            6 => 'Bottom',
+            7 => 'Lower-left',
+            8 => 'Left',
+            9 => 'Upper-left',
+        },
+    },
+    0x15 => { #JR
+        Name => 'FocusMode',
+        Condition => '$$self{Model} =~ /^(DSLR-A(450|500|550))\b/',
+        PrintConv => {
+            0 => 'Manual',
+            1 => 'AF-S',
+            2 => 'AF-C',
+            3 => 'AF-A',
+        },
+    },
+    0x18 => { #JR
+        Name => 'AFPoint',
+        Condition => '$$self{Model} =~ /^DSLR-A(450|500|550)\b/',
+        PrintConv => {
+            0 => 'Top-right',
+            1 => 'Bottom-right',
+            2 => 'Bottom',
+            3 => 'Middle Horizontal',
+            4 => 'Center Vertical',
+            5 => 'Top',
+            6 => 'Top-left',
+            7 => 'Bottom-left',
+        },
+    },
+    0x19 => { #JR
+        Name => 'FocusStatus',
+        Condition => '$$self{Model} =~ /^(SLT-|DSLR-A(560|580))\b/',
+        Notes => 'not valid with Contrast AF or for NEX models',
+        # seen the following values:
+        #  0 with MF (A35, A55V-HDR, A560, A580), non-AF lens (A35), and A580 Contrast-AF
+        #  4 with MF (A33, A55V), and A580 Contrast-AF
+        # 16 with AF-C (or AF-A) and focus OK
+        # 24 with AF-C (or AF-A) and unsharp or fast moving subject e.g. bird in flight
+        # 64 with AF-S (or AF-A) and focus OK
+        PrintConv => {
+            0 => 'Manual - Not confirmed (0)',
+            4 => 'Manual - Not confirmed (4)',
+            16 => 'AF-C - Confirmed',
+            24 => 'AF-C - Not Confirmed',
+            64 => 'AF-S - Confirmed',
+        },
+    },
+    0x1b => { #JR
+        Name => 'AFStatusActiveSensor',
+        Condition => '$$self{Model} =~ /^DSLR-A(450|500|550)\b/',
+        %Image::ExifTool::Minolta::afStatusInfo,
+    },
+    0x1c => {
+        Name => 'AFPointSelected',  # (v8.88: renamed from LocalAFAreaPointSelected)
+        Condition => '$$self{Model} =~ /^(SLT-|DSLR-A(560|580))\b/',
+        Notes => 'not valid for Contrast AF', #JR
+        # (all of these cameras have an 15-point three-cross AF system, ref JR)
+        PrintConvColumns => 2,
+        PrintConv => {
+            0 => 'Auto', # (seen in Wide mode)
+            1 => 'Center',
+            2 => 'Top',
+            3 => 'Upper-right',
+            4 => 'Right',
+            5 => 'Lower-right',
+            6 => 'Bottom',
+            7 => 'Lower-left',
+            8 => 'Left',
+            9 => 'Upper-left',
             10 => 'Far Right',
             11 => 'Far Left',
-            # have seen value of 128 for A230, A330, A380 - PH
-        },
+            12 => 'Upper-middle',
+            13 => 'Near Right',
+            14 => 'Lower-middle',
+            15 => 'Near Left',
+        },
+    },
+    0x1d => [
+        {
+            Name => 'FocusMode',
+            Condition => '$$self{Model} =~ /^(SLT-|DSLR-A(560|580))\b/',
+            PrintConv => {
+                0 => 'Manual',
+                1 => 'AF-S',
+                2 => 'AF-C',
+                3 => 'AF-A',
+            },
+        },{ #JR
+            Name => 'AFStatusTop-right',
+            Condition => '$$self{Model} =~ /^DSLR-A(450|500|550)\b/',
+            %Image::ExifTool::Minolta::afStatusInfo,
+        },
+    ],
+    0x1f => { #JR
+        Name => 'AFStatusBottom-right',
+        Condition => '$$self{Model} =~ /^DSLR-A(450|500|550)\b/',
+        %Image::ExifTool::Minolta::afStatusInfo,
+    },
+    0x20 => { #JR
+        Name => 'AFPoint',  # (v8.88: renamed from LocalAFAreaPointUsed)
+        Condition => '$$self{Model} =~ /^(SLT-|DSLR-A(560|580))\b/',
+        Notes => 'the AF sensor used for focusing. Not valid for Contrast AF',
+        PrintConvColumns => 2,
+        PrintConv => {
+            %afPoint15,
+            255 => '(none)', #PH (A55, guess; also A35 with non-AF lens, ref JR)
+        },
+    },
+    0x21 => [ #JR
+        {
+            Name => 'AFStatusActiveSensor',
+            Condition => '$$self{Model} =~ /^(SLT-|DSLR-A(560|580))\b/',
+            %Image::ExifTool::Minolta::afStatusInfo,
+        },{
+            Name => 'AFStatusBottom',
+            Condition => '$$self{Model} =~ /^DSLR-A(450|500|550)\b/',
+            %Image::ExifTool::Minolta::afStatusInfo,
+        },
+    ],
+    0x23 => [ #JR
+        {
+            Name => 'AFStatus15',
+            Condition => '$$self{Model} =~ /^(SLT-|DSLR-A(560|580))\b/',
+            Format => 'int16s[18]',
+            SubDirectory => { TagTable => 'Image::ExifTool::Sony::AFStatus15' },
+        },{
+            Name => 'AFStatusMiddleHorizontal', # MiddleHorizontal is any of the 3 central horizontal sensors
+            Condition => '$$self{Model} =~ /^DSLR-A(450|500|550)\b/',
+            %Image::ExifTool::Minolta::afStatusInfo,
+        },
+    ],
+    0x25 => { Name => 'AFStatusCenterVertical',   Condition => '$$self{Model} =~ /^DSLR-A(450|500|550)\b/', %Image::ExifTool::Minolta::afStatusInfo },
+    0x27 => { Name => 'AFStatusTop',              Condition => '$$self{Model} =~ /^DSLR-A(450|500|550)\b/', %Image::ExifTool::Minolta::afStatusInfo },
+    0x29 => { Name => 'AFStatusTop-left',         Condition => '$$self{Model} =~ /^DSLR-A(450|500|550)\b/', %Image::ExifTool::Minolta::afStatusInfo },
+    0x2b => { Name => 'AFStatusBottom-left',      Condition => '$$self{Model} =~ /^DSLR-A(450|500|550)\b/', %Image::ExifTool::Minolta::afStatusInfo },
+    # the 3 MiddleHorizontal sensors:
+    0x2d => { Name => 'AFStatusLeft',             Condition => '$$self{Model} =~ /^DSLR-A(450|500|550)\b/', %Image::ExifTool::Minolta::afStatusInfo },
+    0x2f => { Name => 'AFStatusCenterHorizontal', Condition => '$$self{Model} =~ /^DSLR-A(450|500|550)\b/', %Image::ExifTool::Minolta::afStatusInfo },
+    0x31 => { Name => 'AFStatusRight',            Condition => '$$self{Model} =~ /^DSLR-A(450|500|550)\b/', %Image::ExifTool::Minolta::afStatusInfo },
+    # 0x0166 - starting here there are 96 AF Info blocks of 155 bytes each for the SLT-A33/A35/A55 and DSLR-A560/A580,
+    #          starting here there are 86 AF Info blocks of 174 bytes each for the DSLR-A450/A500/A550,
+    #          but NOT for NEX, and not for the A580 in Contrast-AF mode (ref JR)
+    #          The 43rd byte of each block for A580 appears to be the AFPoint as in offset 0x20,
+    #          possibly also 73rd and 74th byte
+);
+
+# Camera information for other models (ref PH)
+%Image::ExifTool::Sony::CameraInfoUnknown = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+);
+
+# white balance and other camera information (ref PH)
+%Image::ExifTool::Sony::FocusInfo = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    PRIORITY => 0,
+    NOTES => q{
+        More camera settings and focus information decoded for models such as the
+        A200, A230, A290, A300, A330, A350, A380, A390, A700, A850 and A900.
+    },
+    0x0e => [{ #7/JR
+        Name => 'DriveMode2',
+        Condition => '$$self{Model} =~ /^DSLR-A(230|290|330|380|390)$/',
+        Notes => 'A230, A290, A330, A380 and A390',
+        ValueConvInv => '$val',
+        PrintHex => 1,
+        PrintConv => { # (values confirmed for specified models - PH)
+            0x01 => 'Single Frame', # (A230,A330,A380)
+            0x02 => 'Continuous High', #PH (A230,A330)
+            0x04 => 'Self-timer 10 sec', # (A230)
+            0x05 => 'Self-timer 2 sec, Mirror Lock-up', # (A230,A290,A330,A380,390)
+            0x07 => 'Continuous Bracketing', # (A230,A330)
+            0x0a => 'Remote Commander', # (A230)
+            0x0b => 'Continuous Self-timer', # (A230,A330)
+        },
+    },{
+        Name => 'DriveMode2',
+        Notes => 'A200, A300, A350, A700, A850 and A900',
+        ValueConvInv => '$val',
+        PrintHex => 1,
+        PrintConv => {
+            0x01 => 'Single Frame',
+            0x02 => 'Continuous High', # A700/A900; not on A850
+            0x12 => 'Continuous Low', #JR
+            0x04 => 'Self-timer 10 sec',
+            0x05 => 'Self-timer 2 sec, Mirror Lock-up',
+            0x06 => 'Single-frame Bracketing',
+            0x07 => 'Continuous Bracketing',
+            0x18 => 'White Balance Bracketing Low', #JR
+            0x28 => 'White Balance Bracketing High', #JR
+            0x19 => 'D-Range Optimizer Bracketing Low', #JR
+            0x29 => 'D-Range Optimizer Bracketing High', #JR
+            0x0a => 'Remote Commander', #JR
+            0x0b => 'Mirror Lock-up', #JR (A850/A900; not on A700)
+        },
+    }],
+    0x10 => { #JR (1 and 2 inverted!)
+        Name => 'Rotation',
+        PrintConv => {
+            0 => 'Horizontal (normal)',
+            1 => 'Rotate 270 CW',
+            2 => 'Rotate 90 CW',
+        },
+    },
+    0x14 => {
+        Name => 'ImageStabilizationSetting',
+        PrintConv => { 0 => 'Off', 1 => 'On' },
     },
     0x15 => { #7
-        Name => 'MeteringMode',
-        Condition => '$$self{Model} !~ /DSLR-A230/',
-        PrintConv => {
-            1 => 'Multi-segment',
-            2 => 'Center-weighted Average',
-            4 => 'Spot',
-        },
-    },
-    0x16 => {
-        Name => 'ISOSetting',
-        Condition => '$$self{Model} !~ /DSLR-A230/',
-        # 0 indicates 'Auto' (I think)
-        ValueConv => '$val ? exp(($val/8-6)*log(2))*100 : $val',
-        ValueConvInv => '$val ? 8*(log($val/100)/log(2)+6) : $val',
-        PrintConv => '$val ? sprintf("%.0f",$val) : "Auto"',
-        PrintConvInv => '$val =~ /auto/i ? 0 : $val',
-    },
-    0x18 => { #7
         Name => 'DynamicRangeOptimizerMode',
-        Condition => '$$self{Model} !~ /DSLR-A230/',
         PrintConv => {
             0 => 'Off',
@@ -733,14 +2945,40 @@
             2 => 'Advanced Auto',
             3 => 'Advanced Level',
-            4097 => 'Auto', #PH (A550)
-        },
-    },
-    0x19 => { #7
-        Name => 'DynamicRangeOptimizerLevel',
-        Condition => '$$self{Model} !~ /DSLR-A230/',
-    },
-    0x1a => { # style actually used (combination of mode dial + creative style menu)
+        },
+    },
+    0x2b => { #JR seen 2,1,3 for both WB and DRO bracketing
+        Name => 'BracketShotNumber',
+        Notes => 'WB and DRO bracketing',
+    },
+    0x2c => { #JR
+        Name => 'WhiteBalanceBracketing',
+        PrintConv => {
+            0 => 'Off',
+            1 => 'Low',
+            2 => 'High',
+        },
+    },
+    0x2d => { #JR seen 2,1,3 for both WB and DRO bracketing
+        Name => 'BracketShotNumber2',
+    },
+    0x2e => { #JR
+        Name => 'DynamicRangeOptimizerBracket',
+        PrintConv => {
+            0 => 'Off',
+            1 => 'Low',
+            2 => 'High',
+        },
+    },
+    0x2f => { #JR seen 0,1,2 and 0,1,2,3,4 for 3 and 5 image bracketing sequences
+        Name => 'ExposureBracketShotNumber',
+    },
+    0x3f => { #JR
+        Name => 'ExposureProgram',
+        SeparateTable => 'ExposureProgram',
+        PrintConv => \%sonyExposureProgram,
+    },
+    0x41 => { #JR style actually used (combination of mode dial + creative style menu)
         Name => 'CreativeStyle',
-        Condition => '$$self{Model} !~ /DSLR-A230/',
+        PrintConvColumns => 2,
         PrintConv => {
             1 => 'Standard',
